/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	v1beta1 "github.com/minio/minio-operator/pkg/apis/miniocontroller/v1beta1"
	scheme "github.com/minio/minio-operator/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// MinioInstancesGetter has a method to return a MinioInstanceInterface.
// A group's client should implement this interface.
type MinioInstancesGetter interface {
	MinioInstances(namespace string) MinioInstanceInterface
}

// MinioInstanceInterface has methods to work with MinioInstance resources.
type MinioInstanceInterface interface {
	Create(*v1beta1.MinioInstance) (*v1beta1.MinioInstance, error)
	Update(*v1beta1.MinioInstance) (*v1beta1.MinioInstance, error)
	UpdateStatus(*v1beta1.MinioInstance) (*v1beta1.MinioInstance, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1beta1.MinioInstance, error)
	List(opts v1.ListOptions) (*v1beta1.MinioInstanceList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.MinioInstance, err error)
	MinioInstanceExpansion
}

// minioInstances implements MinioInstanceInterface
type minioInstances struct {
	client rest.Interface
	ns     string
}

// newMinioInstances returns a MinioInstances
func newMinioInstances(c *MinioV1beta1Client, namespace string) *minioInstances {
	return &minioInstances{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the minioInstance, and returns the corresponding minioInstance object, and an error if there is any.
func (c *minioInstances) Get(name string, options v1.GetOptions) (result *v1beta1.MinioInstance, err error) {
	result = &v1beta1.MinioInstance{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("minioinstances").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of MinioInstances that match those selectors.
func (c *minioInstances) List(opts v1.ListOptions) (result *v1beta1.MinioInstanceList, err error) {
	result = &v1beta1.MinioInstanceList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("minioinstances").
		VersionedParams(&opts, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested minioInstances.
func (c *minioInstances) Watch(opts v1.ListOptions) (watch.Interface, error) {
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("minioinstances").
		VersionedParams(&opts, scheme.ParameterCodec).
		Watch()
}

// Create takes the representation of a minioInstance and creates it.  Returns the server's representation of the minioInstance, and an error, if there is any.
func (c *minioInstances) Create(minioInstance *v1beta1.MinioInstance) (result *v1beta1.MinioInstance, err error) {
	result = &v1beta1.MinioInstance{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("minioinstances").
		Body(minioInstance).
		Do().
		Into(result)
	return
}

// Update takes the representation of a minioInstance and updates it. Returns the server's representation of the minioInstance, and an error, if there is any.
func (c *minioInstances) Update(minioInstance *v1beta1.MinioInstance) (result *v1beta1.MinioInstance, err error) {
	result = &v1beta1.MinioInstance{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("minioinstances").
		Name(minioInstance.Name).
		Body(minioInstance).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *minioInstances) UpdateStatus(minioInstance *v1beta1.MinioInstance) (result *v1beta1.MinioInstance, err error) {
	result = &v1beta1.MinioInstance{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("minioinstances").
		Name(minioInstance.Name).
		SubResource("status").
		Body(minioInstance).
		Do().
		Into(result)
	return
}

// Delete takes name of the minioInstance and deletes it. Returns an error if one occurs.
func (c *minioInstances) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("minioinstances").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *minioInstances) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("minioinstances").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched minioInstance.
func (c *minioInstances) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.MinioInstance, err error) {
	result = &v1beta1.MinioInstance{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("minioinstances").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
